defmodule NullaWeb.ActivityPub.ActorJSON do
  alias Nulla.Actors.Actor

  @doc """
  Renders a single actor.
  """
  def show(actor) do
    data(actor)
  end

  defp data(%Actor{} = actor) do
    Jason.OrderedObject.new(
      "@context": [
        "https://www.w3.org/ns/activitystreams",
        "https://w3id.org/security/v1",
        Jason.OrderedObject.new(
          manuallyApprovesFollowers: "as:manuallyApprovesFollowers",
          alsoKnownAs: %{"@id" => "as:alsoKnownAs", "@type" => "@id"},
          movedTo: %{"@id" => "as:movedTo", "@type" => "@id"},
          schema: "http://schema.org#",
          PropertyValue: "schema:PropertyValue",
          value: "schema:value",
          Hashtag: "as:Hashtag",
          vcard: "http://www.w3.org/2006/vcard/ns#"
        )
      ],
      id: actor.ap_id,
      type: actor.type,
      following: actor.following,
      followers: actor.followers,
      inbox: actor.inbox,
      outbox: actor.outbox,
      featured: actor.featured,
      featuredTags: actor.featuredTags,
      preferredUsername: actor.preferredUsername,
      name: actor.name,
      summary: actor.summary,
      url: actor.url,
      manuallyApprovesFollowers: actor.manuallyApprovesFollowers,
      discoverable: actor.discoverable,
      indexable: actor.indexable,
      published: actor.published,
      memorial: actor.memorial,
      publicKey: actor.publicKey,
      tag: actor.tag,
      attachment: actor.attachment,
      endpoints: actor.endpoints,
      icon: actor.icon,
      image: actor.image,
      "vcard:bday": actor.vcard_bday,
      "vcard:Address": actor.vcard_Address
    )
  end
end
